<script setup lang="ts">
import type { IBDsRNA } from "~/utils/types/ibeetle";
import type { Phenotype } from "~/utils/types/phenotype";
import { IBEETLE_EXPERIMENTS } from "~/utils/types/ibeetle";

const props = defineProps<{ dsrna: IBDsRNA; phenotypes: Phenotype[] }>();
const phenotypes = props.phenotypes.reduce(
  (acc, p) => {
    const experimentId = p.iBeetleExperiment || "Unknown";
    if (acc[experimentId]) {
      acc[experimentId].push(p);
    } else {
      acc[experimentId] = [p];
    }
    return acc;
  },
  {} as Record<string, Phenotype[]>,
);
const sequences = [
  {
    title: `${props.dsrna.id} left primer`,
    text: "View left primer",
    sequences: [
      {
        id: `${props.dsrna.id} left primer`,
        seq: props.dsrna.leftPrimer,
      },
    ],
  },
  {
    title: `${props.dsrna.id} dsRNA sequence`,
    text: "View dsRNA sequence",
    sequences: [
      {
        id: `${props.dsrna.id}`,
        seq: props.dsrna.seq,
      },
    ],
  },
  {
    title: `${props.dsrna.id} right primer`,
    text: "View right primer",
    sequences: [
      {
        id: `${props.dsrna.id} right primer`,
        seq: props.dsrna.rightPrimer,
      },
    ],
  },
];
</script>

<template>
  <v-row class="pa-4">
    <v-col cols="12" xl="7">
      <div class="mb-2">
        <span class="mb-2 mr-2 d-inline-block">
          <IBWorkflow header="Workflow Pupal Screen">
            <img
              src="/pupal_screen.svg"
              alt="Workflow Pupal Screen"
              style="width: 100%"
            />
          </IBWorkflow>
        </span>
        <span class="mb-2 mr-2 d-inline-block">
          <IBWorkflow header="Workflow Larval Screen">
            <img
              src="/larval_screen.svg"
              alt="Workflow Larval Screen"
              style="width: 100%"
            />
          </IBWorkflow>
        </span>
      </div>
      <IBLethality :dsrna-id="props.dsrna.id" />
    </v-col>
    <v-col>
      <SequenceList :sequences="sequences" />
    </v-col>
  </v-row>
  <v-row>
    <v-col cols="12">
      <template v-for="exp in IBEETLE_EXPERIMENTS" :key="exp.id">
        <IBPhenotypeList
          v-if="phenotypes[exp.id]"
          :experiment="exp"
          :phenotypes="phenotypes[exp.id]"
        />
      </template>
    </v-col>
  </v-row>
</template>
